# llewan-weixin-sdk

1、公共参数说明

    game->游戏代码

    version->游戏版本

    ts->时间戳

    sign->签名

    token->用户登陆返回token

    source_id->市场推广广告参数

    dev_platform->开发平台，目前weixin和toutiao
    
    #v1.003版本新增
    
    llewan_sdk_version->sdk版本号
    
    env->切换正式环境以及测试环境
    


2、登陆WeChatLogin的逻辑说明

    2.1 如果用户本地存储中没有用户资料和授权记录。则当用户打开游戏调用login新增一个用户，

    然后调用用户授权后更新用户信息

    2.2 如果用户本地存储中有用户资料但没有授权记录。则当用户打开游戏调用用户授权并且更新用户信息

    2.3 如果用游湖本地存储中用户资料和授权记录都有。则直接进入游戏
    
    #v1.003版本新增
    
    2.4 确定先进行登陆、后进行初始化操作顺序
    
    
    
3、对接流程说明

    3.1 把 assets/llewan-weixin-sdk文件夹拖到项目中
    
    3.2 修改sdk配置文件
    
        var sdk_conf = { 
        
            env: 'prod',            //开发环境，prod或者test
            
            game: 'huaxianqiuqiu',  //乐玩方提供：游戏唯一标识
          
            version: '1.0.1',       //乐玩方提供：当前游戏版本
          
            bannerAdUnitId: '',     //乐玩方提供：banner广告单元id
          
            videoAdUnitId: '',      //乐玩方提供：video广告单元id
            
            dev_platform: 'weixin', //weixin or toutiao
            
            #v1.003新增
            
            lewan_sdk_version:'1.003', //乐玩sdk版本号，不需要修改
          
        };
        
    
    #v1.003版本开始推荐的对接顺序发生了变化,推荐 先登陆 后初始化
    
    3.3 进入游戏第一步新增授权操作
    
        var user = sdk.getUser();
        
        if(user){
        
        	console.log("用户信息：", user)
        	
        }else{
        
        	//.调用sdk登录
        	
        	sdk.WeChatLogin((d)=>{
        	
        	console.log("用户信息：", d)
        	
        	    // 登录成功：返回用户信息； 
        	    
        	    // 登录失败：返回false
        	    
        	});
        	
        }
    
      3.4 进入游戏第二步在启动页面上初始化sdk
    
        sdk.init({
        
            debug: false,         //.是否开启调试
            
        }, (res)=>{
        
            console.log('sdk初始化结果：', res);
            
            var d1 = sdk.getConfig1();
            
            console.log("运营配置按钮控制显示与隐藏信息", d1);
            
        	var d2 = sdk.getConfig2();
        	
            console.log("技术配置信息", d2);
            
            var d3 = sdk.getConfig3();
        	
            console.log("运营配置按钮控制内容", d3);//比如对d1中的hz2按钮进行跳转小游戏控制
            
            var d4 = sdk.getConfig4();
        	
            console.log("特定动态判断配置", d4);//比如特定区域IP不开启某些功能
            
            
            
            
        })
        
    3.5 通过Config1按钮控制显示/隐藏,以下这些配置都在乐玩的游戏后台配置对应按钮的打开与隐藏。
    
        对接时候根据3.1中的游戏（game）以及对应版本（version）通知我们对接策划让他们去后台配置好
    
        {
          "hz": 0,//分享得奖励
          
          "hz2": 0,//跳游戏
          
          "hz3": 0,//跳盒子
          
          "bannerAd": 0,//banner广告
          
          "videoAd": 0,//视频广告开关
          
          "fs": 0,//看广告得奖励
          
          "sns": 0,//社交按钮
          
          "kf": 0,//客服按钮
          
          "gzh": 0//公众号按钮
          
        }
        
        例子：
        
        var d1 = sdk.getConfig1();
        
        if(d1.hz3){
            //.显示盒子
        }else{
        
            //.隐藏盒子
        }
        
    3.6 通过Config3来控制按钮的表现内容以及形式，比如按钮可以在特定时间段打开不同图片、跳转不同游戏、打开不同盒子
        
        在v1.004版本中提供sdk方法实现该功能.
        
        
        
    3.7 游戏中各种分享的接入，接入之前需要通知乐玩对接策划在乐玩后台根据分享类型添加好，对应游戏的各种分享类型
    
        并且分配对应type值，然后给每种分享类型添加对应的分享文案
    
        3.7.1 监听右上角分享按钮，在3.3初始化之后调用如下代码就可以了，query为特殊状况需要传递参数可以使用
        
             sdk.onShareAppMessage({type: 0, query: "xxx=xxx" });
             
        3.7.2 其他分享接入,根据乐玩后台配置好的分享类型，在对应按钮上调用如下代码，type根据类型值变化
        
            sdk.shareAppMessage({type: 1, query: "xxx=xxx" });
    
    3.8 广告的接入

        3.8.1 Banner广告
        
            //var bannerAd = sdk.createBannerAd({
            
            //    style:{
            
            //        left: 0,
            
            //        top: 0,
            
            //        width: 100,
            
            //        height: 200
            
            //    }
            
            //});
      
            //极简版（默认底部Banner）
            
            var bannerAd = sdk.createBannerAd({});
            
            bannerAd.show()
            
        3.8.2 Video广告
        
            //.创建广告
            
            var videoAd = sdk.createRewardedVideoAd();
            
            //.显示广告
            
            videoAd.load().then(() => videoAd.show());
    
    #v1.003增加功能
    
    3.9 将数据保存到服务端，同时本地localStorage保存一份数据。
    
        3.9.1 保存到服务端sdk.setToServer,先保存一份到本地，同时保存一份到服务端，服务端不做任何处理
        
        直接将数据按照失效时间保存到服务端中。注意 失效时间expireTime,-1:表示永不失效;0：表示默认一天失效时间
        
        3.9.2 获取保存数据sdk.getFromServer,如果本地有数据，则获取本地数据直接返回;如果本地数据不存在或者失效,则从服务端获取数据
        
        
    3.10 增加阿拉丁统计事件以及分享
    
        3.10.1 sdk.setAld 统计某个动作的次数
        
        3.10.2 sdk.aldOnShareAppMessage 通过阿拉丁统计右上角分享次数
        
        3.10.3 sdk.aldShareAppMessage 通过阿拉丁统计分享次数
        
        
    
    

