/**
1.安装apidoc，参考链接：
	http://apidocjs.com
2.按照格式弄好后，执行命令
    apidoc -i ./apiTest/assets/Sdk -o api/
    
    在小程序后台添加合法域名：
        https://game.llewan.com:1899
        https://login.llewan.com:1799
        https://log.llewan.com:1999
        https://res.llewan.com:2099

        https://glog.aldwx.com
 */

var md5 = require("md5");
var mta = require("mta");
var sdk_conf = require("sdk_conf");
var aldgame = require("ald-game");


var sdk = { 
    md5: md5,
    mta: mta,
    ip1: "https://login.llewan.com:1799",
    ip2: "https://game.llewan.com:1899",
    ip3: "https://log.llewan.com:1999",
    ip4: "https://res.llewan.com:2099",
    
    loginBg: "https://res.g.llewan.com/uploadfile/common/20180831/20180831173032_3279.png",
    loginBt: "https://res.g.llewan.com/uploadfile/common/20180831/20180831180006_1583.png",

    debug: false,//是否开启调试

    login: '/Login/common',
    modify: '/Login/modify',
    Config: '/Config/common',
    //游戏数据存储/获取
    set: "/game/set",
    get: "/game/get",

    ConfigData: { 
        "config1": {},
        "config2": {},
        "config3": {},
        "config4": {},
    },
    Share: "/Share/common",
    ShareList: [],
    Logcommon: "/Log/common",

    BannerAd: null,
    VideoAd: null,

    //.即将废弃，请不要操作此变量。
    userid: 0,

    /**
     * @apiGroup A
     * @apiName init
     * @api {初始化sdk} 使用sdk前，必须先初始化一次才能使用 init（初始化sdk）
     *
     * @apiParam {Boolean} [debug=false] 是否开启调试
     * @apiParam {int} [userid] 用户的id（兼容旧游戏，新游戏废弃）
     * 
     * @apiSuccessExample {json} 示例:
     * //.初始化游戏
     *   sdk.init({
     *      debug: true,        //.是否开启调试
     *      userid: 56032607    //.用户的id（兼容旧游戏，新游戏废弃）
     *   }, (res)=>{
     *       console.log('sdk初始化结果：', res)
     *   })
     */
    init(args, callback){
        var self = this;
    
        if(args.debug){
            this.debug = args.debug;
        }
        if(args.userid){
            this.userid = args.userid;
        }
        
        this.checkUpdate();
        
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            //1.初始化后台配置信息
            this.Post(this.ip2 + this.Config, {}, function (d) {
                if (d && d.c == 1) {
                    self.ConfigData = d.d;

                    //2.初始化分享信息
                    self.Post(self.ip2 + self.Share, {}, function (d2) {
                        // console.log("初始化分享信息：",d2)
                        if (d2 && d2.c == 1) {
                            self.ShareList = d2.d;
                        }else{
                            console.log("初始化分享信息失败：",d2)
                        }
                        callback(true);
                    });
                }else{
                    if(self.debug){
                        console.log("后台配置信息初始化失败，再次初始化：",d)
                    }
                    self.init(args, callback);
                }
            });
            
            if(this.getUser()){
                this.userid = this.getUser().uid;
            }
            if(this.userid){
                //2.统计：分享信息 测试：  uid=56032607&share_id=22&share_uid=56032607
                var option = wx.getLaunchOptionsSync();
                // console.log("==option==", option)
                if(option.query.share_id && option.query.uid){
                    option.query.share_uid = option.query.uid;
                    option.query.uid = this.userid;
                    // console.log('==3统计信息==',option)
                    this.Post(this.ip3 + this.Logcommon, { log_type: "ShareEnter", data: JSON.stringify(option) }, function (d) {
                        // console.log("==3统计信息结果==", d)
                    });
                }
                wx.onShow((option)=>{
                    // console.log(option)
                    if(option.query.uid){
                        option.query.share_uid = option.query.uid;
                        option.query.uid = self.userid;
                        // console.log('==4统计信息==',option)
                        self.Post(self.ip3 + self.Logcommon, { log_type: "ShareEnter", data: JSON.stringify(option) }, function (d) {
                            // console.log("==4统计信息结果==", d)
                        });
                    }
                })

                //5.统计：每次打开小游戏调用
                wx.getSystemInfo({
                    success(res){
                        var loginData = res;
                        loginData.uid = self.userid;
                        loginData.share_uid = option.query.share_uid;
                        loginData.scene = option.scene;
                        loginData.source_id = option.query.source_id;
                        loginData.source_id2 = option.query.source_id2;

                        wx.getNetworkType({
                            success(res2){
                                loginData.network_type = res2.networkType;
                                // console.log("======loginData=======", loginData)
                                self.Get(self.ip3 + self.Logcommon, { log_type: "LoginData", data: JSON.stringify(loginData) }, function (d) {
                                    // console.log("==5.统计：每次打开小游戏调用==", d)
                                });
                            }
                        })
                    }
                })
            }

        }

        
    },
     //.根据配置初始化api
     initApi(type){
        if(sdk_conf.env==='prod')
        {
            this.ip1 = sdk_conf.env_apis.prod.ip1;
            this.ip2 = sdk_conf.env_apis.prod.ip2;
            this.ip3 = sdk_conf.env_apis.prod.ip3;
            this.ip4 = sdk_conf.env_apis.prod.ip4;   

        }else
        {
        
            this.ip1 = sdk_conf.env_apis.test.ip1;
            this.ip2 = sdk_conf.env_apis.test.ip2;
            this.ip3 = sdk_conf.env_apis.test.ip3;
            this.ip4 = sdk_conf.env_apis.test.ip4;
        }

        console.log("ip1",this.ip1);
        console.log("ip2",this.ip2);
        console.log("ip3",this.ip3);
        console.log("ip4",this.ip4);
    
    },

    //.根据权重随机获取指定type类型的分享信息。（没有this.ShareList数据不能调用）
    getShareByWeight(type){
        if(this.ShareList.length > 0){
            //1.获取某种type的集合
            var tArray = [];
            for (var i = 0; i < this.ShareList.length; i++) {
                if (type == this.ShareList[i].type) {
                    this.ShareList[i].weight = parseInt(this.ShareList[i].weight);
                    tArray.push(this.ShareList[i]);
                }
            }
            //2.根据权重配比：从i集合（权重越大占比越多）中随机获取。
            var iArray = [];
            for (var i = 0; i < tArray.length; i++) {
                for (var j = 0; j < tArray[i].weight; j++) {
                    iArray.push(i);
                }
            }
            var i = iArray[parseInt(Math.random() * iArray.length)];
            //3.结果处理：正则替换昵称
            var item = tArray[i];
            if(item.title.indexOf("&nickName") != -1){
                item.title = item.title.replace(/&nickName/g, this.getUser().nickName);
            }
            return JSON.parse(JSON.stringify(item));
        }else{
            return null;
        }
    },
    /**
     * @apiGroup C
     * @apiName onShareAppMessage
     * @api {分享} 注册微信右上角分享 onShareAppMessage(分享)
     * @apiParam {int} type=0 后台自定义的分享类型；例如：0：右上角分享、1：普通分享 2：分享加金币
     * @apiParam {String} [title] 转发标题
     * @apiParam {String} [imageUrl] 转发显示图片的链接
     * @apiParam {String} [query] 必须是 key1=val1&key2=val2 的格式。
     * @apiParam {callback} [success] 成功回调
     * @apiParam {callback} [fail] 失败回调
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.onShareAppMessage({type: 0, query: "uid=520" });
     */
    onShareAppMessage(obj){
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            //.微信右上角分享
            wx.showShareMenu({withShareTicket:true})
            wx.onShareAppMessage(function(res){
                //.默认0：右上角分享
                var tpye = 0;
                if(obj.type){
                    tpye = obj.type;
                }
                var shareInfo = self.getShareByWeight(tpye)

                if(obj.title){
                    shareInfo.title = obj.title;
                }
                if(obj.imageUrl){
                    shareInfo.imageUrl = obj.imageUrl;
                }
                if(shareInfo.query){
                    shareInfo.query += obj.query + "&share_id="+shareInfo.sysid + "&uid="+self.userid;
                }else{
                    if(obj.query){
                        shareInfo.query = "share_id="+shareInfo.sysid+"&uid="+self.userid +"&" + obj.query;
                    }else{
                        shareInfo.query = "share_id="+shareInfo.sysid + "&uid="+self.userid;
                    }
                }
                if(obj.success){
                    shareInfo.success = obj.success;
                }
                if(obj.fail){
                    shareInfo.fail = obj.fail;
                }

                //.分享统计 测试：  uid=11&share_id=22
                var option = {'uid': sdk.userid, 'share_id': shareInfo.sysid };
                // console.log('==1统计信息==', { log_type: "ShareClick", data: option })
                self.Get(self.ip3 + self.Logcommon, { log_type: "ShareClick", data: JSON.stringify(option) }, function (d) {
                    // console.log("==1统计信息结果==", d)
                });

                return shareInfo;
            })
        }
    },
    /**
     * @apiGroup C
     * @apiName shareAppMessage
     * @api {分享} 主动拉起微信分享 shareAppMessage(分享)
     * @apiParam {int} type=1 后台自定义的分享类型；例如：0：右上角分享、1：普通分享 2：分享加金币
     * @apiParam {String} [title] 转发标题
     * @apiParam {String} [imageUrl] 转发显示图片的链接
     * @apiParam {String} [query] 必须是 key1=val1&key2=val2 的格式。
     * @apiParam {callback} [success] 成功回调
     * @apiParam {callback} [fail] 失败回调
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.shareAppMessage({type: 1, query: "uid=520" });
     */
    shareAppMessage(obj){
        var self = this;
        //.默认1：普通分享
        var tpye = 1;
        if(obj.type){
            tpye = obj.type;
        }
        var shareInfo = this.getShareByWeight(tpye);
        if(obj.title){
            shareInfo.title = obj.title;
        }
        if(obj.imageUrl){
            shareInfo.imageUrl = obj.imageUrl;
        }
        if(shareInfo.query){
            shareInfo.query += obj.query + "&share_id="+shareInfo.sysid + "&uid="+self.userid;
        }else{
            if(obj.query){
                shareInfo.query = "share_id="+shareInfo.sysid+"&uid="+self.userid +"&" + obj.query;
            }else{
                shareInfo.query = "share_id="+shareInfo.sysid + "&uid="+self.userid;
            }
        }
        if(obj.success){
            shareInfo.success = obj.success;
        }
        if(obj.fail){
            shareInfo.fail = obj.fail;
        }
        console.log("wx share", shareInfo);
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.shareAppMessage(shareInfo);

            //.分享统计 测试： uid=11&share_id=22
            var option = {'uid': sdk.userid, 'share_id': shareInfo.sysid };
            // console.log('==2统计信息==', { log_type: "ShareClick", data: option })
            self.Get(self.ip3 + self.Logcommon, { log_type: "ShareClick", data: JSON.stringify(option) }, function (d) {
                // console.log("==2统计信息结果==", d)
            });
        }
    },

    /**
     * @apiGroup C
     * @apiName aldOnShareAppMessage
     * @api {分享} 注册微信右上角分享 aldOnShareAppMessage(分享) 阿拉丁统计
     * @apiParam {int} type=0 后台自定义的分享类型；例如：0：右上角分享、1：普通分享 2：分享加金币
     * @apiParam {String} [title] 转发标题
     * @apiParam {String} [imageUrl] 转发显示图片的链接
     * @apiParam {String} [query] 必须是 key1=val1&key2=val2 的格式。
     * @apiParam {callback} [success] 成功回调
     * @apiParam {callback} [fail] 失败回调
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.aldOnShareAppMessage({type: 0, query: "uid=520" });
     */
    aldOnShareAppMessage(obj){
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            //.微信右上角分享
            wx.showShareMenu({withShareTicket:true})
            wx.aldOnShareAppMessage(function(res){
                //.默认0：右上角分享
                var tpye = 0;
                if(obj.type){
                    tpye = obj.type;
                }
                var shareInfo = self.getShareByWeight(tpye)

                if(obj.title){
                    shareInfo.title = obj.title;
                }
                if(obj.imageUrl){
                    shareInfo.imageUrl = obj.imageUrl;
                }
                if(shareInfo.query){
                    shareInfo.query += obj.query + "&share_id="+shareInfo.sysid + "&uid="+self.userid;
                }else{
                    if(obj.query){
                        shareInfo.query = "share_id="+shareInfo.sysid+"&uid="+self.userid +"&" + obj.query;
                    }else{
                        shareInfo.query = "share_id="+shareInfo.sysid + "&uid="+self.userid;
                    }
                }
                if(obj.success){
                    shareInfo.success = obj.success;
                }
                if(obj.fail){
                    shareInfo.fail = obj.fail;
                }

                return shareInfo;
            })
        }
    },
    /**
     * @apiGroup C
     * @apiName aldShareAppMessage
     * @api {分享} 主动拉起微信分享 aldShareAppMessage(分享) 阿拉丁统计
     * @apiParam {int} type=1 后台自定义的分享类型；例如：0：右上角分享、1：普通分享 2：分享加金币
     * @apiParam {String} [title] 转发标题
     * @apiParam {String} [imageUrl] 转发显示图片的链接
     * @apiParam {String} [query] 必须是 key1=val1&key2=val2 的格式。
     * @apiParam {callback} [success] 成功回调
     * @apiParam {callback} [fail] 失败回调
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.aldShareAppMessage({type: 1, query: "uid=520" });
     */
    aldShareAppMessage(obj){
        var self = this;
        //.默认1：普通分享
        var tpye = 1;
        if(obj.type){
            tpye = obj.type;
        }
        var shareInfo = this.getShareByWeight(tpye);
        if(obj.title){
            shareInfo.title = obj.title;
        }
        if(obj.imageUrl){
            shareInfo.imageUrl = obj.imageUrl;
        }
        if(shareInfo.query){
            shareInfo.query += obj.query + "&share_id="+shareInfo.sysid + "&uid="+self.userid;
        }else{
            if(obj.query){
                shareInfo.query = "share_id="+shareInfo.sysid+"&uid="+self.userid +"&" + obj.query;
            }else{
                shareInfo.query = "share_id="+shareInfo.sysid + "&uid="+self.userid;
            }
        }
        if(obj.success){
            shareInfo.success = obj.success;
        }
        if(obj.fail){
            shareInfo.fail = obj.fail;
        }
        console.log("ald share", shareInfo);
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.aldShareAppMessage(shareInfo);

           
        }
    },

    /**
     * @apiIgnore
     * @apiGroup B
     * @apiName initmta
     * @api {初始化腾讯统计sdk} 参考链接http://mta.qq.com/wechat_mini/manage/ctr_sdk_help?app_id=500625714 initmta（腾讯统计）
     * @apiParam {Object} args 参数
     * 
     * @apiSuccessExample {json} 示例:
     * //.简单
     * mta.App.init({
     *     "appID":"500618042",
     *     "eventID":"500618044"
     * });
     * //.高级
     * mta.App.init({
     *     "appID":"500618042",
     *     "eventID":"500618044", // 高级功能-自定义事件统计ID，配置开通后在初始化处填写
     *     "lauchOpts":options, //渠道分析,需在onLaunch方法传入options,如onLaunch:function(options){...}
     *     "statPullDownFresh":true, // 使用分析-下拉刷新次数/人数，必须先开通自定义事件，并配置了合法的eventID
     *     "statShareApp":true, // 使用分析-分享次数/人数，必须先开通自定义事件，并配置了合法的eventID
     *     "statReachBottom":true // 使用分析-页面触底次数/人数，必须先开通自定义事件，并配置了合法的eventID
     * });
     */
    initmta(args){
        mta.App.init(args);
        // 功能组件
        // App id: 500625714
        // App Secret key: 9b0fd6393ca10f5eebe0d1c659a460ab
    },
    /**
     * @apiIgnore
     * @apiGroup B
     * @apiName setmta
     * @api {腾讯统计埋点} 统计埋点 setmta
     * @apiParam {String} name 腾讯后台查询
     * @apiParam {String} value 腾讯后台查询
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.setmta("click","p003")
     */
    setmta(name, value){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            mta.Event.stat(name, { value: 'true' })
        }
    },
    /**
     * @apiGroup B
     * @apiName setAld
     * @api {阿拉丁埋点} 统计埋点(使用前请到阿拉丁注册游戏，并配置sdk/ald-game-conf.js) setAld（阿拉丁埋点）
     * @apiParam {String} type 描述用户的动作名称，不超过255个字符,不支持数字,英文,中文,"-"、"_"、"+",以外的字符格式
     * @apiParam {String} key 动作的参数，不超过255个字符，不支持数字，英文，中文，"-"、"_"、"+"，以外的字符格式
     * @apiParam {String} value 动作的参数值，不超过255个字符，不支持数字，英文，中文，“-“、”_”、"+"，以外的字符格式
     * 
     * @apiSuccessExample {json} 示例:
     * //使用前，在开发者设置中添加 request合法域名https://glog.aldwx.com
     * //统计类型（点击）， 统计位置（开始游戏按钮），  统计参数（点了1次）
     * sdk.setAld("click", "playButton", "1")
     */
    setAld(type, key, value){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            // wx.aldSendEvent('事件名称',{'参数key' : '参数value'})、
            wx.aldSendEvent(type,  { key : value })
        }
    },

    /**
     * @apiGroup C
     * @apiName Get
     * @api {Get} 发起网络请求 Get（发起Get请求）
     * 
     * @apiParam {String} url 请求地址
     * @apiParam {Object} reqData 请求参数
     * @apiParam {Object} callback 不存在返回null
     * @apiSuccessExample {json} 示例:
     * sdk.Get("https://xxx.xxx", { user_id: user_id }, function (d) {
     *     console.log(d)
     * });
     */
    Get(url, reqData, callback) {
        var self = this;

        reqData.game = sdk_conf.game;
        reqData.version = sdk_conf.version;
        reqData.dev_platform = sdk_conf.dev_platform;
        reqData.llewan_sdk_version = sdk_conf.llewan_sdk_version;
        var ts = new Date().getTime();
        reqData.ts = ts;
        var token = "";
        if(this.getUser())
        {
            token = this.getUser().token;
        }
        var options = wx.getLaunchOptionsSync();
        
        var source_id = options.query.source_id;   
        //数据验证签名。规则为：MD5(ts.substr(9,4)+game.substr(0,2)+version.substr(0,1)+key),时间戳后4位、data前3位、key（服务端提供）然后进行MD5加密
        reqData.sign = md5(ts.toString().substr(9,4)+sdk_conf.game.substr(0,2)+sdk_conf.version.substr(0,1)+ sdk_conf.md5_key);
        
        url += "?";
        for (var item in reqData) {
            url += item + "=" + reqData[item] + "&";
        }
        url += "token="+token+"&";

        url += "source_id="+source_id+"&";

        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                if (xhr.status >= 200 && xhr.status < 400) {
                    var response = xhr.responseText;
                    if (response) {
                        var responseJson = JSON.parse(response);
                        callback(responseJson);
                    } else {
                        if(self.debug){
                            console.log("返回数据不存在",url)
                        }
                        callback(null);
                    }
                } else {
                    if(self.debug){
                        console.log("请求失败",url)
                    }
                    callback(null);
                }
            }
        };
        //console.log("get url is :",url);
        xhr.open("GET", url, true);
        xhr.send();
    },
    
    /**
     * @apiGroup C
     * @apiName Post
     * @api {Post} 发起网络请求 Post（发起Post请求）
     * 
     * @apiParam {String} url 请求地址
     * @apiParam {Object} reqData 请求参数
     * @apiParam {Object} callback 不存在返回null
     * @apiSuccessExample {json} 示例:
     * sdk.Post(sdk.ip + sdk.common, { user_id: user_id }, function (d) {
     *     console.log(d)
     * });
     */
    Post: function (url, reqData, callback) {
        var self = this;
        
        reqData.game = sdk_conf.game;
        reqData.version = sdk_conf.version;
        reqData.dev_platform = sdk_conf.dev_platform;
        reqData.llewan_sdk_version = sdk_conf.llewan_sdk_version;
        var ts = new Date().getTime();
        var token = "";
        if(this.getUser())
        {
            token = this.getUser().token;
        }
        var options = wx.getLaunchOptionsSync();
        var source_id = options.query.source_id;   

        reqData.ts = ts;
        reqData.sign = md5(ts.toString().substr(9,4)+sdk_conf.game.substr(0,2)+sdk_conf.version.substr(0,1)+ sdk_conf.md5_key);
        
        //1.拼接请求参数
        var param = "";
        for (var item in reqData) {
            param += item + "=" + reqData[item] + "&";
        }
        param +="token="+token+ "&";
        param += "source_id="+source_id+"&";
      

        //2.发起请求
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                if (xhr.status >= 200 && xhr.status < 400) {
                    var response = xhr.responseText;
                    // console.log(response)
                    if (response) {
                        var responseJson = JSON.parse(response);
                        callback(responseJson);
                    } else {
                        if(self.debug){
                            console.log("返回数据不存在")
                        }
                        callback(null);
                    }
                } else {
                    if(self.debug){
                        console.log("请求失败",xhr)
                    }
                    callback(null);
                }
            }
        };
        xhr.open("POST", url, true);
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        xhr.send(param);//reqData为字符串形式： "key=value"
    },
    /**
     * @apiGroup C
     * @apiName checkUpdate
     * @api {检测版本更新} 微信小游戏（冷启动的时候会检查，如果有更新则会重启小游戏进行更新） checkUpdate（版本更新）
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.checkUpdate();
     */
    checkUpdate() {
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME && typeof wx.getUpdateManager === 'function') {
            const updateManager = wx.getUpdateManager()
            updateManager.onCheckForUpdate(function (res) {
                if(self.debug){
                    console.log("请求完新版本信息的回调", res.hasUpdate)
                }
            })
            updateManager.onUpdateReady(function () {
                if(self.debug){
                    console.log("新的版本已经下载好，调用 applyUpdate 应用新版本并重启")
                }
                updateManager.applyUpdate()
            })
            updateManager.onUpdateFailed(function () {
                if(self.debug){
                    console.log("新的版本下载失败")
                }
            })
        }
    },
    /**
     * @apiGroup C
     * @apiName getConfig1
     * @api {运营配置} 游戏后台配置信息，运营人员使用的通用配置开关 getConfig1（运营配置）
     * @apiParam {Object} callback 不存在返回null
     * 
     * @apiSuccessExample {json} 示例:
     * var d = sdk.getConfig1();
     */
    getConfig1(){
        return JSON.parse(this.ConfigData.config1);
    },
    
    /**
     * @apiGroup C
     * @apiName getConfig2
     * @api {程序配置} 游戏后台配置信息，程序员使用的游戏数据开关，可随便自定义数据：例如复活次数等 getConfig2（程序配置）
     * @apiParam {Object} callback 不存在返回null
     * 
     * @apiSuccessExample {json} 示例:
     * var d = sdk.getConfig2();
     */
    getConfig2(){
        return JSON.parse(this.ConfigData.config2);
    },

     /**
     * @apiGroup C
     * @apiName getConfig3
     * @api {运营配置} 游戏后台配置信息，运营人员使用的通用配置开关 相关按钮根据时间来配置以及跳转方式按钮属性getConfig3（运营配置）
     * @apiParam {Object} callback 不存在返回null
     * 
     * @apiSuccessExample {json} 示例:
     * var d = sdk.getConfig3();
     */
    getConfig3(){
        return JSON.parse(this.ConfigData.config3);
    },

     /**
     * @apiGroup C
     * @apiName getConfig4
     * @api {技术程序控制} 游戏服务端控制一些需要服务端判断的比如：ip地区配置，getConfig4（技术程序）
     * @apiParam {Object} callback 不存在返回null
     * 
     * @apiSuccessExample {json} 示例:
     * var d = sdk.getConfig4();
     */
    getConfig4(){
        return JSON.parse(this.ConfigData.config4);
    },
    
    /**
     * @apiGroup C
     * @apiName createImage
     * @api {显示网络图片} 微信小游戏加载图片 createImage（显示图片）
     * @apiParam {cc.Sprite} sprite 显示图片的Sprite
     * @apiParam {String} url 需要加载的图片地址
     * 
     * @apiSuccessExample {json} 示例:
     * var data = sdk.createImage(advs);
     */
    createImage(sprite, url) {
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            let image = wx.createImage();
            image.onload = function () {
                let texture = new cc.Texture2D();
                texture.initWithElement(image);
                texture.handleLoadedTexture();
                sprite.spriteFrame = new cc.SpriteFrame(texture);
            };
            image.src = url;
        }
        
    },
    /**
     * @apiGroup C
     * @apiName getUser
     * @api {获取本地用户信息} 获取本地用户信息（登录成功后，会在本地存储用户信息） getUser（获取用户信息）
     * 
     * @apiSuccessExample {json} 示例:
     * //.不存在返回null
     * var user = sdk.getUser();
     */
    getUser(){
        var userinfo = this.getItem('userinfo');
        if(userinfo){
            return JSON.parse(userinfo);
        }else{
            return null;
        }
    },
    /**
     * @apiGroup C
     * @apiName setItem
     * @api {set} 数据存储 setItem（存）
     * @apiParam {String} key 键
     * @apiParam {String} value 值
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.setItem("nick","hello")
     */
    setItem(key, value){
        cc.sys.localStorage.setItem(key, value);
    },
    /**
     * @apiGroup C
     * @apiName getItem
     * @api {数据存储} 数据存储 getItem（取）
     * @apiParam {String} key 键
     * @apiParam {String} value 值
     * 
     * @apiSuccessExample {json} 示例:
     * var nick = sdk.getItem("nick")
     */
    getItem(key){
        return cc.sys.localStorage.getItem(key);
    },
    /**
     * @apiGroup C
     * @apiName onMessage
     * @api {主域监听子域发送的消息} 主域监听子域发送的消息 onMessage（监听消息）
     * @apiParam {callback} callback 回调函数
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.onMessage((d)=>{
     *     console.log(d)
     * })
     */
    onMessage(callback){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.onMessage(function(d){
                // if(d.message == "common_back"){//.子域: 返回子域首页
                //     cc.director.loadScene("common_children")
                // }
                callback(d)
            });
        }
    },
    /**
     * @apiGroup C
     * @apiName postMessage
     * @api {主域向子域发送消息} 主域向子域发送消息 postMessage（发送消息）
     * @apiParam {String} msg 发送给子域的消息
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.postMessage("hello")
     */
    postMessage(msg){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.postMessage({ message: msg });
        }
    },
    //.主域上报数据:    对用户托管数据进行写数据操作，允许同时写多组 KV 数据。
    setUserCloudStorage(kvDataList, callback){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.setUserCloudStorage({
                KVDataList: kvDataList,
                success(res){
                    callback(res)
                },
                fail(res){
                    callback(res)
                }
            })
        }
    },
    //.获取当前用户托管数据当中对应 key 的数据。该接口只可在开放数据域下使用
    getUserCloudStorage(keyList, callback){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.getUserCloudStorage({
                keyList: keyList,
                success(res){
                    callback(res)
                },
                fail(res){
                    callback(res)
                }
            })
        }
    },
    //.在小游戏是通过群分享卡片打开的情况下，可以通过调用该接口获取群同玩成员的游戏数据。该接口只可在开放数据域下使用。
    getGroupCloudStorage(shareTicket, keyList, callback){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.getGroupCloudStorage({
                shareTicket: shareTicket,
                keyList: keyList,
                success(res){
                    callback(res)
                },
                fail(res){
                    callback(res)
                }
            })
        }
    },
    //.拉取当前用户所有同玩好友的托管数据。该接口只可在开放数据域下使用
    getFriendCloudStorage(keyList, callback){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            wx.getFriendCloudStorage({
                keyList: keyList,
                success(res){
                    callback(res)
                },
                fail(res){
                    callback(res)
                }
            })
        }
    },
    /**
     * @apiGroup C
     * @apiName sortList
     * @api {对子域数据进行排序} 对子域数据进行排序 sortList（子域排序）
     * @apiParam {String} ListData 要排序的微信子域数据
     * @apiParam {String} field 排序字段
     * @apiParam {String} order 正序：true  ； 倒序：false
     * 
     * @apiSuccessExample {json} 示例:
     * wx.getFriendCloudStorage({
     *       keyList: ["score"],
     *       success(res){
     *           var ListData = sdk.sortList(res.data, 'score', true));
     *           console.log("=排序后的数据=", ListData);
     *       },
     *       fail(){
     *           console.log(res)
     *       }
     *})
     */
    sortList(ListData, field, order){
        ListData.sort(function(a,b){
            var AMaxScore = 0;
            var KVDataList = a.KVDataList;
            for(var i=0; i<KVDataList.length; i++){
                if(KVDataList[i].key == field){
                    AMaxScore = KVDataList[i].value;
                }
            }

            var BMaxScore = 0;
            KVDataList = b.KVDataList;
            for(var i=0; i<KVDataList.length; i++){
                if(KVDataList[i].key == field){
                    BMaxScore = KVDataList[i].value;
                }
            }

            if(order){
                return parseInt(AMaxScore) - parseInt(BMaxScore);
            }else{
                return parseInt(BMaxScore) - parseInt(AMaxScore);
            }
        });
        return ListData;
    },
    /**
     * @apiIgnore
     * @apiGroup C
     * @apiName getMyRank3
     * @api {排名与我相邻的3位玩家信息} 排名与我相邻的3位玩家信息 getMyRank3（Top3）
     * @apiParam {String} ListData 要排序的微信子域数据
     * @apiParam {String} me 我的子域信息
     * 
     * @apiSuccessExample {json} 示例:
     * wx.getUserInfo({
     *       openIdList: ['selfOpenId'],
     *       lang: 'zh_CN',
     *       success(res){
     *          //.Top3
     *          var dList = sdk.getMyRank3(dataList,res.data[0]);
     *          console.log(dList)
     *       },
     *       fail(error) {
     *          console.log(error)
     *       }
     * })
     * 
     * 
     */
    getMyRank3(ListData,me){
        var dataList = [];
        for(var i=0; i<ListData.length; i++){
            if(ListData.length <= 3){
                //.只有3个人或以下
                if(ListData[i].avatarUrl == me.avatarUrl && ListData[i].nickname == me.nickName){
                    ListData[i].isSelf = true;//.标记自己
                }
                dataList = ListData;
                for(var i=0; i<dataList.length; i++){
                    dataList[i].rank = i;
                }                 
            }else{
                if(ListData[i].avatarUrl == me.avatarUrl && ListData[i].nickname == me.nickName){
                    ListData[i].isSelf = true;//.标记自己
                    if(i == ListData.length-1){
                        //.自己分数最低
                        ListData[i].rank = i;
                        ListData[i-1].rank = i-1;
                        ListData[i-2].rank = i-2;
                        dataList.push(ListData[i-2])
                        dataList.push(ListData[i-1])
                        dataList.push(ListData[i])
                    }else if(i==0){
                        //.自己分数最高
                        ListData[i].rank = i;
                        ListData[i+1].rank = i+1;
                        ListData[i+2].rank = i+2;
                        dataList.push(ListData[i])
                        dataList.push(ListData[i+1])
                        dataList.push(ListData[i+2])
                    }else{
                        //.居中
                        ListData[i-1].rank = i-1;
                        ListData[i].rank = i;
                        ListData[i+1].rank = i+1;
                        dataList.push(ListData[i-1])
                        dataList.push(ListData[i])
                        dataList.push(ListData[i+1])
                    }
                    break;        
                }
            }
               
        }
        return dataList;
    },
    /**
     * @apiGroup C
     * @apiName wxLogin
     * @api {微信登录} 微信登录 wxLogin（登录）
     * 
     * @apiSuccessExample {json} 示例:
     * // 2.登录页：获取用户信息
     *   var user = sdk.getUser();
     *   if(user){
     *       console.log("用户信息：", user)
     *   }else{
     *       //.调用sdk登录
     *       sdk.wxLogin((d)=>{
     *           console.log("用户信息：", d)
     *           // 登录成功：返回用户信息； 
     *           // 登录失败：返回false
     *       });
     *   }
     * 
     */
    WxLogin(callback){
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            var options = wx.getLaunchOptionsSync();
            
            var referee_id = options.query.uid;             //.推荐人id
            var source_id = options.query.source_id;        //.用户来源id
            var source_id2 = options.query.source_id2;      //.用户来源子id
            var share_id = options.query.share_id;          //.分享素材ID
            wx.login({
                success(res2){ 
                    var reqData = {   
                        code: res2.code,
                        referee_id: referee_id,
                        source_id: source_id,
                        source_id2: source_id2,
                        share_id: share_id
                    }
                    // console.log('==登录参数==', reqData)
                    self.Post(self.ip1 + self.login, reqData, function(data){
                        // console.log('==登录结果==', data)
                        if(data.c == 1){
                            self.setItem('userinfo', JSON.stringify(data.d));
                            callback(data.d);
                        }else{
                            // console.log('==登录接口请求失败==', data)
                            wx.showToast({title: '登录失败请重试'});
                        }                
                    });
                },
                fail(){
                    wx.showToast({title: '登录失败请重试'});
                    callback(false)
                },
            })
         
        }
    },
 /**
     * @apiGroup C
     * @apiName wxAuth
     * @api {微信授权} 微信登录 wxAuth（授权）
     * 
     * @apiSuccessExample {json} 示例:
     * // 2.登录页：获取用户信息
     *   var user = sdk.getUser();
     *   if(user){
     *       console.log("用户信息：", user)
     *   }else{
     *       //.调用sdk登录
     *       sdk.wxAuth((d)=>{
     *           console.log("用户信息：", d)
     *           // 登录成功：返回用户信息； 
     *           // 登录失败：返回false
     *       });
     *   }
     * 
     */
    WxAuthLogin(callback){
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            var options = wx.getLaunchOptionsSync();
            
            var referee_id = options.query.uid;             //.推荐人id
            var source_id = options.query.source_id;        //.用户来源id
            var source_id2 = options.query.source_id2;      //.用户来源子id
            var share_id = options.query.share_id;          //.分享素材ID
            
            var userinfo = this.getUser();

                //.登录遮罩背景
                var maskNode = new cc.Node('Sprite');
                maskNode.parent = cc.director.getScene().getChildByName('Canvas');
                maskNode.addComponent(cc.BlockInputEvents)
                var sp = maskNode.addComponent(cc.Sprite);
                maskNode.opacity = 178;
                maskNode.color = new cc.Color(25,88,95,255);
                sp.sizeMode = cc.Sprite.SizeMode.CUSTOM;
                self.createImage(sp, self.loginBg);
                maskNode.width = cc.view.getVisibleSize().width;
                maskNode.height = cc.view.getVisibleSize().height;
                // console.log(maskNode.width, maskNode.height)

                //.微信登录按钮
                if(self.button){
                    self.button.show();
                }else{


                    wx.getSystemInfo({
                        success(res){
                            var width = 507/2;
                            var height = 464/2;
                            self.button = wx.createUserInfoButton({
                                type: 'image',
                                image: self.loginBt,
                                style: {  width: width, height: height, left: res.screenWidth/2-width/2, top: res.screenHeight/2-height/2 }
                            })
                            self.button.onTap((res1) => {
                                // 处理用户拒绝授权的情况
                                // if (res1.errMsg.indexOf('auth deny') > -1 || res1.errMsg.indexOf('auth denied') > -1 ) {
                                //     wx.showToast();
                                // }
                                wx.showToast({title: '登录中...',icon:'loading',duration: 8});
                                wx.getSetting({
                                    success(auths){
                                        if(auths.authSetting["scope.userInfo"]){
                                            self.setItem("wxauth",1);
                                            console.log('===已经授权===');

                                            var reqData = {
                                                rawData: res1.rawData,
                                                iv: res1.iv,
                                                encryptedData: res1.encryptedData,
                                                signature: res1.signature,

                                                referee_id: referee_id,
                                                source_id: source_id,
                                                source_id2: source_id2,
                                                share_id: share_id
                                            }
                                            // console.log('==登录参数==', reqData)
                                            self.Post(self.ip1 + self.modify, reqData, function(data){
                                                // console.log('==登录结果==', data)
                                                if(data.c == 1){
                                                    self.setItem('userinfo', JSON.stringify(data.d));
                                                    wx.hideToast();
                                                    maskNode.destroy();
                                                    self.button.hide();
                                                    //.登录成功，重新初始化
                                                    self.userid = data.d.uid;
                                                    self.init({},(d)=>{})

                                                    callback(data.d);
                                                }else{
                                                    // console.log('==登录接口请求失败==', data)
                                                    wx.showToast({title: '登录失败请重试'});
                                                }                
                                            });

                                        }else{
                                            callback(false)
                                        }
                                    }
                                })        
                            })
                            self.button.show()
                        }
                    })
                }


        }
    },
    /**
     * @apiGroup C
     * @apiName WeChatLogin
     * @api {微信登录} 微信登录 WeChatLogin（登录）
     * 
     * @apiSuccessExample {json} 示例:
     * // 2.登录页：获取用户信息
     *   var user = sdk.getUser();
     *   if(user){
     *       console.log("用户信息：", user)
     *   }else{
     *       //.调用sdk登录
     *       sdk.WeChatLogin((d)=>{
     *           console.log("用户信息：", d)
     *           // 登录成功：返回用户信息； 
     *           // 登录失败：返回false
     *       });
     *   }
     * 
     */
    WeChatLogin(callback){

        //根据sdk_conf初始化api
        this.initApi();
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
       
            var userinfo = this.getUser();

            var wxauth = this.getItem("wxauth");     //记录微信是否授权
            if(userinfo&&wxauth){
                console.log("直接进入游戏");
                //用户信息获取到并且授权了
                callback(userinfo)
            }else if(userinfo&&!wxauth)
            {
                //用户信息存在但是没有授权,就应该去授权后调用服务端member/update用户信息
                this.WxAuthLogin((d) => {
                    console.log("授权1");
                    callback(d);
                });

            }else if(!userinfo&&wxauth)
            {
                //用户信息没有但是有授权，就应该去登陆并且去授权后调用服务端member/update用户信息
                this.WxAuthLogin((d) => {
                    console.log("授权2");
                    callback(d);
                });
            }
            else{
                //没有用户信息，也没有授权，就应该去登陆并且去授权后调用服务端member/update用户信息
                this.WxLogin((d) => {
                    console.log("登陆");

                    this.WxAuthLogin((d) => {
                        console.log("授权3");
                        callback(d);
                    });

                });
                
            }
        }
    },

   
    /**
     * @apiGroup C
     * @apiName createBannerAd
     * @api {微信登录} 创建banner广告组件 createBannerAd（广告）
     * @apiParam {String} adUnitId 广告单元id	
     * @apiParam {String} style banner 广告组件的样式
     * 
     * @apiSuccessExample {json} 示例:
     *  //.参考文档：https://developers.weixin.qq.com/minigame/dev/document/ad/wx.createBannerAd.html
     *  //var bannerAd = sdk.createBannerAd({
     *  //    style:{
     *  //        left: 0,
     *  //        top: 0,
     *  //        width: 100,
     *  //        height: 200
     *  //    }
     *  //});
     * 
     *  //.极简版（默认底部Banner）
     *  var bannerAd = sdk.createBannerAd({});
     *  bannerAd.show()
     * 
     */
    createBannerAd(obj){
        var self = this;
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            if(this.BannerAd){
                return this.BannerAd;
            }else{
                if(!obj.style){
                    obj.style = {};
                    var phone = wx.getSystemInfoSync();
                    this.w = phone.screenWidth / 2;
                    this.h = phone.screenHeight;
                    obj.style.left = 0;
                    obj.style.top = 0;
                    obj.style.width = 300;
                }
                this.BannerAd = wx.createBannerAd({
                    adUnitId: sdk_conf.bannerAdUnitId,
                    style: obj.style,
                })
                this.BannerAd.onResize(function(res){
                    console.log("BannerAd广告缩放事件：", res)
                    self.BannerAd.style.left = self.w - self.BannerAd.style.realWidth/2+0.1;
                    self.BannerAd.style.top = self.h - self.BannerAd.style.realHeight+0.1;
                });
                this.BannerAd.onLoad(function(res){
                    console.log("BannerAd广告加载事件：", res)
                });
                this.BannerAd.onError(function(res){
                    console.log("BannerAd广告错误事件：", res)
                });

                return this.BannerAd;
            }
        }
    },
    /**
     * @apiGroup C
     * @apiName createRewardedVideoAd
     * @api {微信登录} 创建banner广告组件 createRewardedVideoAd（广告）
     * @apiParam {String} adUnitId 广告单元id	
     * 
     * @apiSuccessExample {json} 示例:
     * //.参考文档：https://developers.weixin.qq.com/minigame/dev/document/ad/wx.createRewardedVideoAd.html
     *  var videoAd = sdk.createRewardedVideoAd();
     *  videoAd.load().then(() => videoAd.show());
     * 
     */
    createRewardedVideoAd(){
        if (cc.sys.platform === cc.sys.WECHAT_GAME) {
            if(this.VideoAd){
                return this.VideoAd;
            }else{
                this.VideoAd = wx.createRewardedVideoAd({ adUnitId: sdk_conf.videoAdUnitId })
                this.VideoAd.onLoad(function(res){
                    console.log("VideoAd广告加载事件：", res)
                });
                this.VideoAd.onError(function(res){
                    console.log("VideoAd广告错误事件：", res)
                });
                return this.VideoAd;
            }
        }
    },
     /**
     * @apiGroup C
     * @apiName Screenshot
     * @api {微信小游戏截图保存} 微信小游戏截图保存 Screenshot（截图）
     * 
     * @apiSuccessExample {json} 示例:
     *   //.摄像机组件、回调
     *   sdk.Screenshot((d)=>{
     *       if(d){
     *           console.log("图片保存成功：", d)
     *       }else{
     *           console.log("图片保存失败：", d)
     *       }
     *   })
     * 
     */
    Screenshot(callback){
        var self = this;
        //1.判断是否授权
        wx.getSetting({
            success(res){
                // console.log("授权状态", res.authSetting['scope.writePhotosAlbum'])
                if(res.authSetting['scope.writePhotosAlbum']){
                    self.capture(callback);
                }else{
                    // console.log("未授权", res)
                    wx.authorize({
                        scope: 'scope.writePhotosAlbum',
                        success(res2){
                            // console.log("success res2",res2)
                            self.Screenshot(callback);
                        },
                        fail(res2){
                            // console.log("重新授权")
                            wx.showModal({
                                title: '提示',
                                content: '请开启保存到相册功能',
                                showCancel: false,
                                success(){
                                    wx.openSetting({
                                        success(res3){
                                            // console.log("===重新授权===", res3)
                                            if(res3.authSetting['scope.writePhotosAlbum']){
                                                self.Screenshot(callback);
                                            }else{
                                                wx.showToast({ title: "授权失败" })
                                                callback(null)
                                            }
                                        }
                                    })
                                }
                            })
                        }
                    })
                }
            },
            fail(){
                callback(null)
            }
        })
    },
    capture (callback) {
        if(cc.ENGINE_VERSION < "2.0.0"){
            //1.9.3旧版本截图
            var canvas = cc.game.canvas;
            var width  = cc.winSize.width;
            var height  = cc.winSize.height;

            canvas.toTempFilePath({
                x: 0,
                y: 0,
                width: width,
                height: height,
                destWidth: width,
                destHeight: height,
                success (res) {
                    //.可以保存该截屏图片
                    // console.log(res)
                    //.保存到手机
                    wx.saveImageToPhotosAlbum({
                        filePath: res.tempFilePath,
                        success(res2){
                            console.log('==截图保存=success=',res2)
                            callback(true)
                        },
                        fail(res2){
                            console.log('==截图保存=fail=',res2)
                            callback(null)
                        }
                    })
                }
            })
        }else{
            //2.0.1新版本截图
            var cameraNode = new cc.Node('camera');
            cameraNode.parent = cc.director.getScene().getChildByName('Canvas');
            var camera = cameraNode.addComponent(cc.Camera);


            //.要截取的范围（全屏）
            let texture = new cc.RenderTexture();
            // 如果截图内容中不包含 Mask 组件，可以不用传递第三个参数
            let gl = cc.game._renderContext;
            texture.initWithSize(cc.visibleRect.width, cc.visibleRect.height, gl.STENCIL_INDEX8);
            camera.targetTexture = texture;
            this.texture = texture;


            let width = this.texture.width;
            let height = this.texture.height;
            let canvas = document.createElement('canvas');
            let ctx = canvas.getContext('2d');
            canvas.width = width;
            canvas.height = height;
            camera.render();
            let data = this.texture.readPixels();
            let rowBytes = width * 4;
            for (let row = 0; row < height; row++) {
                let srow = height - 1 - row;
                let imageData = ctx.createImageData(width, 1);
                let start = srow*width*4;
                for (let i = 0; i < rowBytes; i++) {
                    imageData.data[i] = data[start+i];
                }
                ctx.putImageData(imageData, 0, row);
            }
            var dataURL = canvas.toDataURL("image/jpeg");
            var tempFilePath = canvas.toTempFilePathSync({
                x: 0,
                y: 0,
                width: width,
                height: height,
                destWidth: width,
                destHeight: height,
            });
            //.保存到手机
            wx.saveImageToPhotosAlbum({
                filePath: tempFilePath,
                success(res2){
                    console.log('==截图保存=success=',res2)
                    callback(true)
                },
                fail(res2){
                    console.log('==截图保存=fail=',res2)
                    callback(null)
                }
            })
        }
        
    },
    //.一般性存储到服务器数据方法，并且做了本地缓存
    /**
     * @apiGroup C
     * @apiName setToServer
     * @api {setToServer} 数据存储 setToServer（存）
     * @apiParam {String} dataKey 键
     * @apiParam {String} dataType 数据类型
     * @apiParam {String} data 需要保存的数据
     * @apiParam {String} expireTime 过期时间 单位(秒),0：默认一天;-1:永不失效(10年);
     * var data = {'key3':'test'};
     * sdk.setToServer("testKeyttt3","TestData",data,3600);
     * 
     */
    setToServer: function(dataKey,dataType,data,expireTime){

        var self = this;
        if(expireTime==-1)
        {
            expireTime=10*365*24*60*60;
        }else if(expireTime==0)
        {
            expireTime=24*60*60;
        }
        dataKey = sdk_conf.game+":"+dataType+":"+dataKey;
        self.setLocalCache(dataKey,JSON.stringify(data),expireTime);
        console.log("setToServer "+dataKey + " value "+JSON.stringify(data));
        this.Get(this.ip2 + this.set, { key: dataKey,data: JSON.stringify(data),data_type:dataType,expireTime:String(expireTime)}, function (d) {
            console.log("setToServer 服务端返回",JSON.stringify(d));
             if(d.c==0)
             {
                console.error("设置失败，请联系服务端技术查看问题！");
                
             }
        });   
    },
    
    //.一般性获取服务器数据方法，并且做了本地缓存
    /**
     * @apiGroup C
     * @apiName getFromServer
     * @api {getFromServer} 数据存储 getFromServer（获取）
     * @apiParam {String} dataKey 键
     * @apiParam {String} dataType 数据类型
     * @apiParam {String} data 特殊情况下需要传递额外数据状况，一般不传递
     * @apiParam {String} callback 回调
     * 
     * sdk.getFromServer("testKey","TestData",null,(d)=>{
                console.log("获取返回",d.key3);
            });
     */
    getFromServer: function(dataKey,dataType,data,callbackFunction){
   
        var self = this;
        dataKey = sdk_conf.game+":"+dataType+":"+dataKey;
        
        var cacheData = this.getLocalCache(dataKey)
        console.log("getFromServer "+dataKey+" 本地获取值："+cacheData);

        if(cacheData==-1)
        {
            //去远程服务器拿数据
            this.Get(this.ip2 + this.get, { key: dataKey,data_type:dataType,data: JSON.stringify(data)}, function (d) {

                console.log("getFromServer "+dataKey+" 本地不存在，去服务器获取值："+JSON.stringify(d.d));
                callbackFunction(d.d);
            });
        }else if(cacheData==0)
        {
            //本地缓存过期了直接返回
            //callbackFunction(null);

            //去远程服务器拿数据
            this.Get(this.ip2 + this.get, { key: dataKey,data_type:dataType,data: JSON.stringify(data)}, function (d) {

                console.log("getFromServer "+dataKey+" 本地已经过期,去服务器获取值："+JSON.stringify(d.d));
                callbackFunction(d.d);
            });

        }else
        {
            //获取到数据
            callbackFunction(JSON.parse(cacheData));
        }
        
    },

     /**
     * @apiGroup C
     * @apiName setItem
     * @api {set} 数据存储 setItem（存）
     * @apiParam {String} key 键
     * @apiParam {String} value 值
     * @apiParam {String} expireTime 过期时间单位(秒)
     * 
     * @apiSuccessExample {json} 示例:
     * sdk.setLocalCache("nick","hello")
     */
    setLocalCache(key, value,expireTime){

        var nowTime = new Date().getTime();
        console.log("setLocalCache nowTime",nowTime);
        expireTime = nowTime+expireTime*1000;
        console.log("setLocalCache expireTime",expireTime);
        var localData=  {'data': value,'expireTime':expireTime};
        cc.sys.localStorage.setItem(key, JSON.stringify(localData));
    },
    /**
     * @apiGroup C
     * @apiName getItem
     * @api {数据存储} 数据存储 getItem（取）
     * @apiParam {String} key 键
     * @apiParam {String} value 值
     * 
     * @apiSuccessExample {json} 示例:
     * var nick = sdk.getLocalCache("nick")
     */
    getLocalCache(key){

        var nowTime = new Date().getTime();
        console.log("getLocalCache nowTime",nowTime);
        var localData =  cc.sys.localStorage.getItem(key);

        console.log("getLocalCache "+key+" 本地获取值："+localData);


        if(localData)
        {
            var data = JSON.parse(localData);
            var expireTime = data.expireTime;
            if(nowTime>=expireTime)
            {
                cc.sys.localStorage.removeItem(key);
                console.log("getLocalCache dataKey : "+key+" is expire");
                return 0;
            }else
            {

                var data = data.data;
                console.log("getLocalCache dataKey : "+key+" is "+data);

                return data;
            }
        }else
        {
            //本地不存在数据,应该去远程服务器拿数据
            return -1;
        }
        
    }


    

};
// module.exports = sdk;
window.sdk = sdk;

